import { isVue2, markRaw } from 'vue-demi';
import { createResource } from './core';
import { debug } from './env';
export var ResourceManagerSymbol = debug
    ? Symbol.for('__VUE_ASYNC_RESOURCE_MANAGER__')
    : Symbol();
export function createResourceManager() {
    var manager = markRaw({
        install: function (app) {
            if (!isVue2) {
                manager._a = app;
                app.config.globalProperties.$createResource = createResource.bind(manager);
                app.provide(ResourceManagerSymbol, manager);
            }
        },
        // it's actually undefined here
        // @ts-expect-error set in install when using Vue 3
        _a: null,
    });
    return manager;
}
//# sourceMappingURL=createManager.js.map