import { COMPONENT_NAME } from './context';
export var suspenseInstanceStack = [];
export var currentSuspenseInstance;
/**
 * push suspense instance
 * @param instance Vue instance
 */
export function pushSuspenseInstance(instance) {
    currentSuspenseInstance = instance;
    suspenseInstanceStack.push(instance);
}
/**
 * pop suspense instance
 */
export function popSuspenseInstance() {
    suspenseInstanceStack.pop();
    return (currentSuspenseInstance = suspenseInstanceStack[suspenseInstanceStack.length - 1]);
}
/**
 *  find suspense instance
 */
export function findSuspenseInstance(ins) {
    var current = ins.$parent;
    while (current) {
        if (current.$options.name === COMPONENT_NAME) {
            return current;
        }
        else {
            current = current.$parent;
        }
    }
    return;
}
//# sourceMappingURL=suspenseInstance.js.map