"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findSuspenseInstance = exports.popSuspenseInstance = exports.pushSuspenseInstance = exports.currentSuspenseInstance = exports.suspenseInstanceStack = void 0;
var context_1 = require("./context");
exports.suspenseInstanceStack = [];
/**
 * push suspense instance
 * @param instance Vue instance
 */
function pushSuspenseInstance(instance) {
    exports.currentSuspenseInstance = instance;
    exports.suspenseInstanceStack.push(instance);
}
exports.pushSuspenseInstance = pushSuspenseInstance;
/**
 * pop suspense instance
 */
function popSuspenseInstance() {
    exports.suspenseInstanceStack.pop();
    return (exports.currentSuspenseInstance = exports.suspenseInstanceStack[exports.suspenseInstanceStack.length - 1]);
}
exports.popSuspenseInstance = popSuspenseInstance;
/**
 *  find suspense instance
 */
function findSuspenseInstance(ins) {
    var current = ins.$parent;
    while (current) {
        if (current.$options.name === context_1.COMPONENT_NAME) {
            return current;
        }
        else {
            current = current.$parent;
        }
    }
    return;
}
exports.findSuspenseInstance = findSuspenseInstance;
//# sourceMappingURL=suspenseInstance.js.map