"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourceManagerVuePlugin = void 0;
var vue_demi_1 = require("vue-demi");
var createResource_1 = require("./core/createResource");
var Suspense_1 = require("./core/Suspense");
var ResourceManagerVuePlugin = /** @class */ (function () {
    function ResourceManagerVuePlugin() {
    }
    ResourceManagerVuePlugin.install = function (Vue, options) {
        if (options === void 0) { options = {}; }
        // Used to avoid multiple mixins being setup
        // when in dev mode and hot module reload
        // https://github.com/vuejs/vue/issues/5089#issuecomment-284260111
        if (Vue.$__resource_manager_installed__)
            return;
        // eslint-disable-next-line @typescript-eslint/camelcase
        Vue.$__resource_manager_installed__ = true;
        Vue.component('Suspense', Suspense_1.Suspense);
        (0, Suspense_1.setSuspenseOptions)(options);
        Object.defineProperties(Vue.prototype, {
            $createResource: {
                value: createResource_1.createResource.bind(null),
                writable: false,
                enumerable: true,
                configurable: true,
            },
        });
    };
    return ResourceManagerVuePlugin;
}());
exports.ResourceManagerVuePlugin = ResourceManagerVuePlugin;
// Auto install if it is not done yet and `window` has `Vue`.
// To allow users to avoid auto-installation in some cases,
if (vue_demi_1.isVue2 && typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(ResourceManagerVuePlugin);
}
//# sourceMappingURL=vue2-plugin.js.map